/*
 *  LessonsSchedule.cs
 *  Copyright (C) 2004-2005 Marcin Krystian Krzywonos
 */


using System;
using System.Collections;
using System.IO;
using System.Xml;


namespace gnutu {
	
	public class LessonsScheduleData {
		static public ArrayList [] data;

		
		static public bool Open ()
		{
			data = new ArrayList [] {new ArrayList (), new ArrayList (), new ArrayList (), 
						new ArrayList (), new ArrayList (), new ArrayList (),
						new ArrayList (), new ArrayList ()};
			
			StreamReader reader;
			
			try {
				reader = new StreamReader (FilesPaths.LessonsScheduleFile (), System.Text.Encoding.UTF8);
			} catch  {
				return false;
			}
			
			XmlTextReader read = new XmlTextReader (reader);
			ArrayList     day  = new ArrayList ();
			
			int i = 0;
			
			try {
				while (read.Read ()) {
					if ((read.NodeType == XmlNodeType.Element) || (read.NodeType == XmlNodeType.EndElement)) {
						if ((read.Name == "day") && (read.NodeType == XmlNodeType.Element)) {
							day = new ArrayList ();
						}
						
						if ((read.Name == "subject") && (read.NodeType == XmlNodeType.Element)) {
							day.Add (read.ReadString ());
						}
						
						if ((read.Name == "day") && (read.NodeType == XmlNodeType.EndElement)) {
							data [i] = day;
							i++;
						}
					}
				}
			} catch {
				reader.Close ();
				return false;
			}
			
			
			i = 1;
			while (i < 7) {
				data [i] = Fill (data [i], data [0].Count);
				i++;
			}
				
		
			reader.Close ();
			return true;
		}
		
		
		static public void Close ()
		{
			XmlTextWriter f = new XmlTextWriter (FilesPaths.LessonsScheduleFile (), System.Text.Encoding.UTF8);
			f.Formatting = Formatting.Indented;
			f.WriteStartDocument ();
			f.WriteStartElement (null, "LessonsSchedule", "http://www.gnutu.org");
			
			int i = 0;
			foreach (ArrayList arr in data) {
				f.WriteStartElement ("day");
					foreach (string day in arr) {
						f.WriteStartElement ("subject");
							f.WriteString (day);
						f.WriteEndElement ();
					}
				f.WriteEndElement ();
				
				i++;
			}
			
			f.WriteEndElement ();
			f.WriteEndDocument ();
			f.Close ();
		}
		
		
		static public ArrayList Get (int day)
		{
			return data [day];
		}
		
		
		static public void Set (int day, ArrayList list)
		{
			data [day] = list;
		}
		
		
		static public ArrayList GetLessonsList ()
		{
			ArrayList list = new ArrayList ();
			
			int i = 1;
			while (i < 7) {
				foreach (string subj in data [i])
					list = AddSubject (list, subj);
				
				i++;
			}
			
			return list;
		}
		
		
		static public ArrayList AddSubject (ArrayList list, string subject)
		{
			if (subject.Length == 0)
				return list;
			
			foreach (string subj in list) {
				if (subj == subject)
					return list;
			}
		
			list.Add (subject);
				
			return list;
		}
		
		
		static private ArrayList Fill (ArrayList list, int count)
		{
			int i = count - list.Count;
			
			while (i > 0) {
				list.Add ("");
				
				i--;
			}
			
			return list;
		}
	}
}
